typedef struct
      {
  int   type;
  int   x, y;
  int   modifiers;
  int   button;
  int   key;
  char *string;
  int wide;
  double flo0, flo1;
      }
    gfx_event_t;

enum
{
  GFXEV_BUTTON_PRESS=1, GFXEV_BUTTON_RELEASE,
  GFXEV_KEY_PRESS,      GFXEV_KEY_RELEASE,
  GFXEV_POINTER_MOVE,   GFXEV_QUIT, GFXEV_LAST,
};


/* The event routine returns an event from the queue. It waits a maximum
   of 'msecs' milliseconds for the event. If msecs is zero, it waits
   until an event is received.

   The return value is one if an event is returned. It's zero if the
   return was due to timeout.

   In case of an event, *msecs is updated to reflect the remaining
   wait time.  */

int gfx_event(unsigned int *msecs,gfx_event_t *Revent);

int gfx_init(char *name, int width, int height, char *title);

#define GFX_UPDATE (1<<0)
#define GFX_ALPHA  (1<<1)
#define GFX_ORDER  (1<<0)    // order returned coordinates
#define GFX_BACKGND (1<<2)   // use background color instead of pixel buffer
#define GFX_JUST_RIGHT (1<<3)
#define GFX_JUST_CENTER (1<<4)
#define GFX_CUT_LEFT (1<<5)
#define GFX_FOCUS (1<<6)
#define GFX_HORIZONTAL (1<<7)
#define GFX_VERTICAL   (1<<8)


void gfx_update(int x,int y,int width,int height);
void gfx_update_all();

enum
{ 
   GFX_K_PRT=1, 
   GFX_K_BACKSPACE,     GFX_K_TAB,      GFX_K_RETURN, GFX_K_ESCAPE,
   GFX_K_INSERT,        GFX_K_DELETE,   GFX_K_HOME,   GFX_K_END,
   GFX_K_PAGEUP,        GFX_K_PAGEDOWN,
   GFX_K_LEFT,          GFX_K_RIGHT,    GFX_K_DOWN,   GFX_K_UP,
   GFX_K_CONTROL=0x100, GFX_K_SHIFT= 0x200 
};

#line 16 "/home/dodo/tmp/gfx/android/../src/menu-fw.u"

typedef struct { int iv1, iv2; char *sv; } TUPiis_t;

#line 65 "gfx.h"

void gfx_geometry(unsigned int *W, unsigned int *H);
void gfx_text_size(int font, char *str, int *W, int *H);
void gfx_print(int flags, int font, int fg, int bg, int x, int y, 
               char *str,int *Rw, int *Rh);
void gfx_get(unsigned int *buffer, int dst_w, int dst_h,
             int dst_x, int dst_y,
             int src_x, int src_y,
             int width, int height);
void gfx_fill_rect(int flags, int dst_x,int dst_y,
                   int w,int h, unsigned int color);
void gfx_draw_rect(int flags, int dst_x,int dst_y,
                   int w,int h, unsigned int color);
void gfx_put_graymap(int flags,
             unsigned char *buffer, int src_w, int src_h,
             int src_x, int src_y,
             int dst_x, int dst_y,
             int width, int height);
void gfx_put(int flags,
             unsigned int *buffer, int src_w, int src_h,
             int src_x, int src_y,
             int dst_x, int dst_y,
             int width, int height);
int gfx_button(int flags,int x,int y, int w, int h, char *str, int action);
void gfx_button_enable(int btn,int a);
int gfx_fwmenu(int font,int nentries, TUPiis_t *entries);
int gfx_label(int flags, int font, int fg, int bg,
              int x,int y, int w, int h, char *str);
void gfx_label_set_text(int flags,int labno, char *str);
int gfx_push_screen();
void gfx_restore_screen(int sn);
