#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "gfx.h"

char *default_fn;
char *files_dir;

void shift(int *argc,char **argv,int i, int a)
{
  for(;i+a<*argc;i++)
    argv[i]= argv[i+a];
  *argc-= a;
}

static char* get_env_mkathome(const char *envname, const char *dname)
{
  char *V;
  char buf[2000];
  V= getenv(envname);
  if (!V)
  {
    char *home;
    home= getenv("HOME");
    if (!home) home="/tmp";
    sprintf(buf,"%s/%s",home,dname);
    V= buf;
  }
  return strdup(V);
}

int main(int argc,char **argv)
{
  int i;
  int small= 0;
  for(i=1;i<argc;i++)
   if (!strcmp(argv[i],"-s"))
   {
     small= 1;
     shift(&argc,argv,i,1);
     i--;
   }

  files_dir= get_env_mkathome("IPAK_FILES_DIR", "IPAKDOC");

  if (argc>1) default_fn= argv[1];
       else  
       {
         char buf[2000];
         sprintf(buf,"%s/default.tar", files_dir);
         default_fn= strdup(buf);
       }
  if (small)
    gfx_init(NULL, 800,480, "Android Test Screen");
  else
    gfx_init(NULL, 1000, 800, "IPAK Viewer");


  android_main(NULL,0);
  return 0;
}
